// Vertex Shader  file "dynamic_shader.vert"
// static means no modifications to the mesh

#version 330 core

uniform mat4 PVM;
uniform mat4 mvMatrix;
uniform mat4 normalMatrix;
uniform mat4 Bones[62];

in  vec4 in_position;
in  vec4 in_weight;
in  vec4 in_boneindices;
in  vec2 in_textCoords;
in  vec3 in_normal;

out vec2 ex_textCoords;
out vec3 ex_normal;
out vec3 ex_ecPosition;
out vec3 ex_eyeVector;


void main(void)
{
	vec4 newVertex;
        vec4 newNormal;
        int index;
	//-----------------------
	index=int(in_boneindices.x);
        newVertex = (Bones[index] * in_position) * in_weight.x;
	newNormal = (Bones[index] * vec4(in_normal, 0.0)) * in_weight.x;

	if(in_boneindices.y != -1) {
	  index=int(in_boneindices.y);
          newVertex = (Bones[index] * in_position) * in_weight.y + newVertex;
	  newNormal = (Bones[index] * vec4(in_normal, 0.0)) * in_weight.y + newNormal;
	}

	if(in_boneindices.z != -1) {
	  index=int(in_boneindices.z);
          newVertex = (Bones[index] * in_position) * in_weight.z + newVertex;
	  newNormal = (Bones[index] * vec4(in_normal, 0.0)) * in_weight.z + newNormal;
	}

	if(in_boneindices.w != -1) {
	  index=int(in_boneindices.w);
          newVertex = (Bones[index] * in_position) * in_weight.w + newVertex;
	  newNormal = (Bones[index] * vec4(in_normal, 0.0)) * in_weight.w + newNormal;
	}
	//-----------------------

	//Get surface normal in eye coordinates
//	ex_normal = (normalMatrix * vec4(in_normal,1.0) ).xyz;
	ex_normal = (normalMatrix * newNormal ).xyz;

	//Get vertex position in eye coordinates
//	ex_ecPosition = (mvMatrix * in_position).xyz;
	ex_ecPosition = (mvMatrix * newVertex).xyz;

	//Get Vector from surface to eye
	ex_eyeVector = normalize(-ex_ecPosition);

	ex_textCoords = in_textCoords;
//	gl_Position = PVM * in_position;
	gl_Position = PVM * vec4(newVertex.xyz, 1.0);
}